package com.example.geoquizzgradletest;

import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    TextView total_questionsTextView;
    TextView questionTextView;
    android.widget.Button ans_A,ans_B,ans_C,ans_D;
    android.widget.Button submit;
    int score = 0;
    int totalQuestion = QnA.questions.size();
    int currentQuestionIndex = 0;
    String selectedAnswer = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        total_questionsTextView = findViewById(R.id.total_questions);
        questionTextView = findViewById(R.id.question);
        ans_A = findViewById(R.id.ans_A);
        ans_B = findViewById(R.id.ans_B);
        ans_C = findViewById(R.id.ans_C);
        ans_D = findViewById(R.id.ans_D);
        submit = findViewById(R.id.submit);

        ans_A.setOnClickListener(this);
        ans_B.setOnClickListener(this);
        ans_C.setOnClickListener(this);
        ans_D.setOnClickListener(this);
        submit.setOnClickListener(this);

        total_questionsTextView.setText("Question " + (currentQuestionIndex + 1) + "/" + totalQuestion);

        loadNewQuestion();
    }

    @Override
    public void onClick(View view) {

        ans_A.setBackgroundColor(Color.WHITE);
        ans_B.setBackgroundColor(Color.WHITE);
        ans_C.setBackgroundColor(Color.WHITE);
        ans_D.setBackgroundColor(Color.WHITE);

        Button clickedButton = (Button) view;
        if(clickedButton.getId()==R.id.submit){
            if(selectedAnswer.equals(QnA.getQuestion(currentQuestionIndex).getAnswer())){
                score++;
            }
            currentQuestionIndex++;
            total_questionsTextView.setText("Question " + (currentQuestionIndex + 1) + "/" + totalQuestion);
            loadNewQuestion();


        }else{
            selectedAnswer = clickedButton.getText().toString();
            clickedButton.setBackgroundColor(Color.MAGENTA);
        }
    }

    void loadNewQuestion(){
        if(currentQuestionIndex == totalQuestion){
            finishQuiz();
            return;
        }

        questionTextView.setText(QnA.getQuestion(currentQuestionIndex).getQuestion());
        ans_A.setText(QnA.getQuestion(currentQuestionIndex).getChoices().get(0));
        ans_B.setText(QnA.getQuestion(currentQuestionIndex).getChoices().get(1));
        ans_C.setText(QnA.getQuestion(currentQuestionIndex).getChoices().get(2));
        ans_D.setText(QnA.getQuestion(currentQuestionIndex).getChoices().get(3));
    }

    void finishQuiz(){
        String passStatus ="";
        if(score > totalQuestion*0.60){
            passStatus = "Passed";

        }else{
            passStatus="Failed";
        }
        new AlertDialog.Builder(this)
                .setTitle(passStatus)
                .setMessage("Votre score est de "+score +"sur"+totalQuestion )
                .setPositiveButton("Restart",((dialogInterface, i) -> restartQuiz()) )
                .setCancelable(false)
                .show();
    }

    void restartQuiz(){
        score = 0;
        currentQuestionIndex = 0;
        total_questionsTextView.setText("Question " + (currentQuestionIndex + 1) + "/" + totalQuestion);
        loadNewQuestion();
    }
}

