package com.example.geoquizzgradletest;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

public class QnA {

    public static ArrayList<Question> questions = new ArrayList<>();

    static {
        ArrayList<Map.Entry<String, String>> countryCapitalPairs = new ArrayList<>();
        countryCapitalPairs.add(Map.entry("France", "Paris"));
        countryCapitalPairs.add(Map.entry("Italie", "Rome"));
        countryCapitalPairs.add(Map.entry("Espagne", "Madrid"));
        countryCapitalPairs.add(Map.entry("Allemagne", "Berlin"));
        countryCapitalPairs.add(Map.entry("Pays-Bas", "Amsterdam"));
        countryCapitalPairs.add(Map.entry("Suisse", "Berne"));
        countryCapitalPairs.add(Map.entry("Royaume-Uni", "Londres"));
        countryCapitalPairs.add(Map.entry("Japon", "Tokyo"));
        countryCapitalPairs.add(Map.entry("Chine", "Pékin"));
        countryCapitalPairs.add(Map.entry("Inde", "New Delhi"));
        countryCapitalPairs.add(Map.entry("États-Unis", "Washington D.C."));
        countryCapitalPairs.add(Map.entry("Canada", "Ottawa"));
        countryCapitalPairs.add(Map.entry("Mexique", "Mexico"));
        countryCapitalPairs.add(Map.entry("Brésil", "Brasília"));
        countryCapitalPairs.add(Map.entry("Argentine", "Buenos Aires"));
        countryCapitalPairs.add(Map.entry("Australie", "Canberra"));
        countryCapitalPairs.add(Map.entry("Nouvelle-Zélande", "Wellington"));
        countryCapitalPairs.add(Map.entry("Russie", "Moscou"));
        countryCapitalPairs.add(Map.entry("Afrique du Sud", "Pretoria"));
        countryCapitalPairs.add(Map.entry("Égypte", "Le Caire"));


        // Mélanger la liste des paires pays-capitale pour obtenir un ordre aléatoire
        Collections.shuffle(countryCapitalPairs);

        for (Map.Entry<String, String> pair : countryCapitalPairs) {
            questions.add(new Question(pair.getKey(), pair.getValue(), countryCapitalPairs));
        }
    }

    public static Question getQuestion(int index) {
        return questions.get(index);
    }

    public static class Question {
        private final String country;
        private final String capital;
        private final ArrayList<String> choices;

        public Question(String country, String capital, ArrayList<Map.Entry<String, String>> countryCapitalPairs) {
            this.country = country;
            this.capital = capital;

            // Créer une liste de toutes les capitales, à l'exception de la bonne réponse
            ArrayList<String> allCapitals = new ArrayList<>();
            for (Map.Entry<String, String> pair : countryCapitalPairs) {
                if (!pair.getValue().equals(capital)) {
                    allCapitals.add(pair.getValue());
                }
            }

            // Mélanger les capitales et prendre les trois premières
            Collections.shuffle(allCapitals);
            choices = new ArrayList<>();
            for (int i = 0; i < 3; i++) {
                choices.add(allCapitals.get(i));
            }

            // Ajouter la réponse correcte à la liste et mélanger les choix
            choices.add(capital);
            Collections.shuffle(choices);
        }

        public String getQuestion() {
            return "Quelle est la capitale de " + country + " ?";
        }

        public ArrayList<String> getChoices() {
            return choices;
        }

        public String getAnswer() {
            return capital;
        }
    }
}

